/*ref. freetype.h*/
 FT_ULong get_char_code( FT_Face   face,  FT_UInt   charindex){
	/*face->charmap. reverse of    FT_Get_Char_Index, if FT_Get_Char_Index succeeded.*/
        FT_ULong  charcode;                                              
	FT_UInt   gindex;
                                                                         
	if(charindex==0)return 0;
        charcode = FT_Get_First_Char( face, &gindex );                   
        while ( gindex != 0 )                                            
        {                                                                
          if(gindex==charindex) return charcode;
          charcode = FT_Get_Next_Char( face, charcode, &gindex );        
        }                                                                
	return 0;
      }                                                                  

/*ref. bdf/bdf.h*/

  typedef struct  bdf_bbx_t_
  {
    unsigned short  width;
    unsigned short  height;

    short           x_offset;
    short           y_offset;

    short           ascent;
    short           descent;

  } bdf_bbx_t;


  typedef struct  bdf_glyph_t_
  {
    char*           name;        /* Glyph name.                          */
    long            encoding;    /* Glyph encoding.                      */
    unsigned short  swidth;      /* Scalable width.                      */
    unsigned short  dwidth;      /* Device width.                        */
    bdf_bbx_t       bbx;         /* Glyph bounding box.                  */
    unsigned char*  bitmap;      /* Glyph bitmap.                        */
    unsigned long   bpr;         /* Number of bytes used per row.        */
    unsigned short  bytes;       /* Number of bytes used for the bitmap. */

  } bdf_glyph_t;


  typedef struct  bdf_glyphlist_t_
  {
    unsigned short  pad;          /* Pad to 4-byte boundary.              */
    unsigned short  bpp;          /* Bits per pixel.                      */
    long            start;        /* Beginning encoding value of glyphs.  */
    long            end;          /* Ending encoding value of glyphs.     */
    bdf_glyph_t*    glyphs;       /* Glyphs themselves.                   */
    unsigned long   glyphs_size;  /* Glyph structures allocated.          */
    unsigned long   glyphs_used;  /* Glyph structures used.               */
    bdf_bbx_t       bbx;          /* Overall bounding box of glyphs.      */

  } bdf_glyphlist_t;
  
/*ref. bdf/bdfdrivr.c*/  
//#include "test2.c.lnk"
#include "/mnt/disk-d/src2/font/test2.c"
inline char test_sp(char c){
	return (c==' ') ;}
#include "unidrivr1.c"
FT_CALLBACK_DEF( FT_Error )
  universal_load_glyph( FT_GlyphSlot  slot,
                  FT_Size       size,
                  FT_UInt       glyph_index,
                  FT_Int32      load_flags )
  {
    FT_Face      face   = FT_SIZE_FACE( size );
    FT_Error     error  = FT_Err_Ok;
    FT_Bitmap*   bitmap = &slot->bitmap;
    bdf_glyph_t  glyph;FT_UInt       default_glyph;
    int          bpp    = 8;
    //static bdf_glyphlist_t bdffont_v;

    FT_UNUSED( load_flags );


    if ( !face )
    {
      error = FT_THROW( Invalid_Face_Handle );
      goto Exit;
    }

    if ( glyph_index >= (FT_UInt)face->num_glyphs )
    {Arg:
      error = FT_THROW( Invalid_Argument );
      goto Exit;
    }
    FT_ULong charcode=get_char_code(face,glyph_index) ;
    if ( charcode == (FT_ULong)0 /*||charcode==(FT_ULong)'e'*/)      goto Arg;
	/*todo check face->charmap->encoding*/

	/*//set glyphs
	//set default_glyph*/
	#include "unidrivr2.c"

    FT_TRACE1(( "%s: glyph index %d\n","", glyph_index ));

    /* index 0 is the undefined glyph */
    if ( glyph_index == 0 ||TRUE)
      glyph_index = default_glyph;
    else
      glyph_index-=1;

    if ( /*glyph_index == 0*/!glyph.bitmap )      goto Arg;

    /* slot, bitmap => freetype, glyph => bdflib */
    //glyph = bdffont_v.glyphs[glyph_index];

    bitmap->rows  = glyph.bbx.height;
    bitmap->width = glyph.bbx.width;
    if ( glyph.bpr > INT_MAX )
      FT_TRACE1(( "%s: too large pitch %d is truncated\n","",
                   glyph.bpr ));
    bitmap->pitch = (int)glyph.bpr; /* same as FT_Bitmap.pitch */

    /* note: we don't allocate a new array to hold the bitmap; */
    /*       we can simply point to it                         */
    ft_glyphslot_set_bitmap( slot, glyph.bitmap );

    switch ( bpp )
    {
    case 1:
      bitmap->pixel_mode = FT_PIXEL_MODE_MONO;
      break;
    case 2:
      bitmap->pixel_mode = FT_PIXEL_MODE_GRAY2;
      break;
    case 4:
      bitmap->pixel_mode = FT_PIXEL_MODE_GRAY4;
      break;
    case 8:
      bitmap->pixel_mode = FT_PIXEL_MODE_GRAY;
      bitmap->num_grays  = 256;
      break;
    }

    slot->format      = FT_GLYPH_FORMAT_BITMAP;
    slot->bitmap_left = glyph.bbx.x_offset;
    slot->bitmap_top  = glyph.bbx.ascent;

    slot->metrics.horiAdvance  = (FT_Pos)( glyph.dwidth * 64 );
    slot->metrics.horiBearingX = (FT_Pos)( glyph.bbx.x_offset * 64 );
    slot->metrics.horiBearingY = (FT_Pos)( glyph.bbx.ascent * 64 );
    slot->metrics.width        = (FT_Pos)( bitmap->width * 64 );
    slot->metrics.height       = (FT_Pos)( bitmap->rows * 64 );

    /*
     * XXX DWIDTH1 and VVECTOR should be parsed and
     * used here, provided such fonts do exist.
     */
    ft_synthesize_vertical_metrics( &slot->metrics,
                                    /*bdffont_v.*/glyph.bbx.height * 64 );
#ifndef unidrivr2_vers1
//x_offset+;dwidth-
//.ascent-;also set vertAdvance to 2/3
    slot->metrics.vertAdvance  = (FT_Pos)( glyph.bbx.descent * 64 );
#endif

  Exit:
    return error;
  }